/**
 *  @file   tiny_gettext_ja.c
 *  @brief  {gettext̑́A蔲ȓ{pgettext.
 *  @author tenk@6809.net
 *  @note
 *      gettextp̎w肪ȂȂ̂ŁAPɑΉԂB
 *      {ꃁbZ[W po/ja.po ̂(v2.2.7)e[u܂B
 */

#include <stdio.h>
#include <assert.h>
#include "config.h"
#include "libgettext.h"

/*
# SOME DESCRIPTIVE TITLE.
# Copyright (C) 2002 Free Software Foundation, Inc.
# GOTO Masanori <gotom@debian.or.jp>, 2002.
#

"Project-Id-Version: indent 2.2.7\n"
"POT-Creation-Date: 2002-12-16 16:12+0000\n"
"PO-Revision-Date: 2002-01-13 02:30+0900\n"
"Last-Translator: GOTO Masanori <gotom@debian.or.jp>\n"
"Language-Team: Japanese <ja@li.org>\n"
"MIME-Version: 1.0\n"
"Content-Type: text/plain; charset=EUC-JP\n"
"Content-Transfer-Encoding: 8bit\n"
*/

static char *msgEn2JaTbl_data[][2] = {
    {           /* src/args.c:543        */
        "usage: indent file [-o outfile ] [ options ]\n",
        "gp@: indent t@C [-o o̓t@C ] [ IvV ]\n",

    }, {        /* src/args.c:544        */
        "       indent file1 file2 ... fileN [ options ]\n",
        "       indent t@C1 t@C2 ... t@CN [ IvV ]\n",

    }, {        /* src/args.c:609       , c-format */
        "indent: missing argument to parameter %s\n",
        "indent: p[^ %s ւ̈܂\n",

    }, {        /* src/args.c:717       , c-format */
        "indent: unknown option \"%s\"\n",
        "indent: sȃIvV \"%s\"\n",

    }, {        /* src/args.c:728       , c-format */
        "option: %s\n",
        "IvV: %s\n",

    }, {        /* src/args.c:744       , c-format */
        "GNU indent %s\n",
        "GNU indent %s\n",

    }, {        /* src/args.c:827       , c-format */
        "indent: option ``%s'' requires a numeric parameter\n",
        "indent: IvV g%sh ɂ͐lp[^Kvł\n",

    }, {        /* src/args.c:836       , c-format */
        "indent: set_option: internal error: p_type %d\n",
        "indent: set_option: G[: p_type %d\n",

    }, {        /* src/args.c:892       , fuzzy */
        "Profile contains an unterminated comment",
        "vt@C͓K؂łȂ܂ł܂",

    }, {        /* src/args.c:929        */
        "Profile contains unpalatable characters",
        "vt@C͓K؂łȂ܂ł܂",

    }, {        /* src/backup.c:404      */
        "indent:  Strange version-control value\n",
        "indent:   version-control lł\n",

    }, {        /* src/backup.c:405      */
        "indent:  Using numbered-existing\n",
        "indent:  numbered-existing gp܂\n",

    }, {        /* src/backup.c:434     , c-format */
        "indent: Can't make backup filename of %s\n",
        "indent: obNAbvt@C %s 쐬ł܂\n",

    }, {        /* src/backup.c:442     , c-format */
        "Can't open backup file %s",
        "obNAbvt@C %s J܂",

    }, {        /* src/backup.c:449     , c-format */
        "Can't write to backup file %s",
        "obNAbvt@C %s ɏ߂܂",

    }, {        /* src/backup.c:463     , c-format */
        "Can't preserve modification time on backup file %s",
        "obNAbvt@C %s ̕ύXۑł܂ł",

    }, {        /* src/globs.c:41 src/globs.c:64         */
        "indent: Virtual memory exhausted.\n",
        "indent: gʂ܂.\n",

    }, {        /* src/globs.c:79       , c-format */
        "indent: %s:%d: %s:",
        "indent: %s:%d: %s:",

    }, {        /* src/globs.c:93        */
        "indent: Fatal Error: ",
        "indent: vIG[: ",

    }, {        /* src/globs.c:103       */
        "indent: System Error: ",
        "indent: VXeG[: ",

    }, {        /* src/globs.h:25        */
        "Warning",
        "x",

    }, {        /* src/globs.h:29        */
        "Error",
        "G[",

    }, {        /* src/indent.c:156      */
        "Ran out of memory",
        "gʂ܂",

    }, {        /* src/indent.c:588 src/indent.c:1248       , c-format */
        "Extra %c",
        "]v %c",

    }, {        /* src/indent.c:1352 src/indent.c:1378 src/indent.c:2438         */
        "Line broken",
        "sĂ܂",

    }, {        /* src/indent.c:1969         */
        "Unmatched #else",
        "#else v܂",

    }, {        /* src/indent.c:1970         */
        "Unmatched #elif",
        "#elif v܂",

    }, {        /* src/indent.c:1997         */
        "Unmatched #endif",
        "#endif v܂",

    }, {        /* src/indent.c:2381         */
        "EOF encountered in comment",
        "Rg EOF ɑ܂",

    }, {        /* src/indent.c:2610         */
        "Unexpected end of file",
        "z肵ĂȂt@C̏I[ł",

    }, {        /* src/indent.c:2616        , c-format */
        "There were %d non-blank output lines and %d comments\n",
        "s %d sARg %d s܂\n",

    }, {        /* src/indent.c:2620        , c-format */
        "(Lines with comments)/(Lines with code): %6.3f\n",
        "(Rgt̍s)/(R[ht̍s): %6.3f\n",

    }, {        /* src/indent.c:2644         */
        "Line broken 2",
        "sĂ܂ 2",

    }, {        /* src/indent.c:2846        , c-format */
        "indent: only one output file (2nd was %s)\n",
        "indent: B̏o̓t@C (2Ԗڂ %s ł)\n",

    }, {        /* src/indent.c:2855 src/indent.c:2881       */
        "indent: only one input file when output file is specified\n",
        "indent: o̓t@Cw肳ꂽƂ̗B̓̓t@Cł\n",

    }, {        /* src/indent.c:2869 src/indent.c:2916       */
        "indent: can't have filenames when specifying standard input\n",
        "indent: W͂Ŏw肳ꂽɃt@C܂ł\n",

    }, {        /* src/indent.c:2889         */
        "indent: only one input file when stdout is used\n",
        "indent: stdout gpꂽB̓̓t@Cł\n",

    }, {        /* src/indent.c:3103        , c-format */
        "Read profile %s\n",
        "vt@C %s ǂ݂܂\n",

    }, {        /* src/io.c:187      */
        "Internal buffering error",
        "obt@OG[",

    }, {        /* src/io.c:349     , c-format */
        "Can't open input file %s",
        "̓t@C %s J܂",

    }, {        /* src/io.c:354     , c-format */
        "Can't stat input file %s",
        "̓t@C %s  stat ł܂",

    }, {        /* src/io.c:359     , c-format */
        "Warning: Zero-length file %s",
        "x: [̃t@C %s ł",

    }, {        /* src/io.c:367     , c-format */
        "File %s is too big to read",
        "t@C %s ͓Ǎނɂ͑傫܂",

    }, {        /* src/io.c:375     , c-format */
        "System problem reading file %s",
        "t@C %s ǍݒɃVXe肪܂",

    }, {        /* src/io.c:399     , c-format */
        "Error reading input file %s",
        "̓t@C %s ̓Ǎ݃G[",

    }, {        /* src/io.c:404     , c-format */
        "Error closeing input file %s",
        "̓t@C %s ƂɃG[",

    }, {        /* src/io.c:588     , c-format */
        "Warning: File %s contains NULL-characters\n",
        "x: t@C %s  NULL܂ł܂\n",

    }, {        /* src/lexi.c:756        */
        "Unterminated character constant",
        "萔IĂ܂",

    }, {        /* src/lexi.c:757        */
        "Unterminated string constant",
        "񂪏IĂ܂",

    }, {        /* src/lexi.c:999       , c-format */
        "old style assignment ambiguity in \"=%c\".  Assuming \"= %c\"\n",
        "\"=%c\" ͌ÂX^C̞BȋLqł. \"= %c\" Ɖ肵܂\n",

    }, {        /* src/output.c:1148        , c-format */
        "indent: can't create %s\n",
        "indent: %s 쐬ł܂\n",

    }, {        /* src/output.c:1187        , c-format */
        "Can't close output file %s",
        "o̓t@C %s ܂",

    }, {        /* src/output.c:1200        , c-format */
        "Can't preserve modification time on output file %s",
        "o̓t@C %s ̕ύXۑł܂ł",

    }, {        /* src/parse.c:399       */
        "Unmatched 'else'",
        "'else' sv",

    }, {        /* src/parse.c:425       */
        "Stmt nesting error.",
        "stmt lXgG[.",

    }, {        /* src/parse.c:467       */
        "Unknown code to parser",
        "p[T[ւ̕sȃR[h",

    }, {        /* src/parse.c:477      , fuzzy, c-format */
        "ParseStack [%d]:\n",
        "ParseStack [%d]:\n",

    }, {        /* src/parse.c:481      , c-format */
        "  stack[%d] =>   stack: %d   ind_level: %d\n",
        "  stack[%d] =>   stack: %d   ind_level: %d\n",

    }, {        /* src/wildexp.c:90      */
        "CANNOT FIND '@' FILE!",
        "'@' t@C܂!",
    }, {
        "       -he  short|long options\n",
        "       -he  Z| IvVꗗ\n",
    }, {
        "       -ho  options-help for Japanese\n",
        "       -ho  IvV\n",
    },
};


/* -------------------------------------------------------------------------*/

enum {MSG_EN2JA_NUM = sizeof(msgEn2JaTbl_data)/sizeof(msgEn2JaTbl_data[0])};
static char *msgEn2JaTbl[MSG_EN2JA_NUM][2];
static int  msgEn2JaTbl_num;
/*static*/int  jpn_env_flg = 1;



/* -------------------------------------------------------------------------*/

static int msgEn2JaTbl_add(char *tbl[][2], int *tblcnt, char *key[2]);
static int msgEn2Ja_search(char *tbl[][2], int nn, const char *key);


/* -------------------------------------------------------------------------*/
#if !defined(FORCE_JAPANESE)
# include <windows.h>
#endif

void textdomain(const char *dmy_domainName)
{
    int i;

  #if defined (_WIN32)
   #if defined (FORCE_JAPANESE)
    jpn_env_flg = 1;
   #else
    jpn_env_flg = (GetThreadLocale() == 0x411);
   #endif
  #endif
    if (jpn_env_flg) {
        msgEn2JaTbl_num = 0;
        for (i = 0; i < MSG_EN2JA_NUM; i++) {
            msgEn2JaTbl_add(&msgEn2JaTbl[0], &msgEn2JaTbl_num, msgEn2JaTbl_data[i]);
        }
    }
}


char *gettext(const char *msgid)
{
    if (jpn_env_flg) {
        int  n;
        n = msgEn2Ja_search(msgEn2JaTbl, msgEn2JaTbl_num, msgid);
        if (n >= 0)
            return msgEn2JaTbl[n][1];
    }
    return (char *)msgid;
}


static int msgEn2JaTbl_add(char *tbl[][2], int *tblcnt, char *key[2])
{
    int  low, mid, f, hi;

    hi = *tblcnt;
    mid = low = 0;
    while (low < hi) {
        mid = (low + hi - 1) / 2;
        f = strcmp(key[0], tbl[mid][0]);
        if (f < 0) {
            hi = mid;
        } else if (f > 0) {
            mid++;
            low = mid;
        } else {
            assert(0);  //mvOŒǉ邱Ƃ͂Ȃ̂Ń`FbN
            return -1;
        }
    }
    (*tblcnt)++;
    for (hi = *tblcnt; --hi > mid;) {
        tbl[hi][0] = tbl[hi-1][0];
        tbl[hi][1] = tbl[hi-1][1];
    }
    tbl[mid][0] = key[0];
    tbl[mid][1] = key[1];
    return 0;
}


static int msgEn2Ja_search(char *tbl[][2], int nn, const char *key)
{
    int     low, mid, f;

    low = 0;
    while (low < nn) {
        mid = (low + nn - 1) / 2;
        f = strcmp(key, tbl[mid][0]);
        if (f < 0)
            nn = mid;
        else if (f > 0)
            low = mid + 1;
        else
            return mid;
    }
    return -1;
}

